package com.anpgames.beans.application;

import java.util.HashMap;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.bean.ApplicationScoped;
import javax.faces.bean.ManagedBean;

import com.anpgames.slsbeans.basic.user.UserBeanLocal;

@ManagedBean
@ApplicationScoped
public class PermissionsSupportMB {
	public static final String PAGE_SUFFIX = ".faces";
	public static final String MODULES_PATH = "/modules/";
	public static final String M_ADMIN_PATH = MODULES_PATH + "admin/";
	public static final String M_REPORT_PATH = MODULES_PATH + "report/";
	
	public static final int M_ADMIN_PERM_NUM = 1000;
	public static final int M_REPORT_PERM_NUM = 2000;
	
	private HashMap<String, Integer> pagesPermNumbers;
	
	@EJB UserBeanLocal userBean;
	
	@PostConstruct
	public void init() {
		initPagesPermNumbers();
	}
	
	public void initPagesPermNumbers() {
		pagesPermNumbers = new HashMap<String, Integer>();
		//ADMIN
		//uzytkownicy
		pagesPermNumbers.put(M_ADMIN_PATH + "usersList" + PAGE_SUFFIX, 1010);
		pagesPermNumbers.put(M_ADMIN_PATH + "usersEdit" + PAGE_SUFFIX, 1020);
		//role
		pagesPermNumbers.put(M_ADMIN_PATH + "rolesList" + PAGE_SUFFIX, 1110);
		pagesPermNumbers.put(M_ADMIN_PATH + "rolesEdit" + PAGE_SUFFIX, 1120);
	}
	
	public int getPagePermNumber(String key) {
		Integer pagePermNumber = pagesPermNumbers.get(key);
		//jezeli nie znaleziono klucza zwracana jest wartosc ujemna
		if (pagePermNumber == null)
			return -1;
		return pagePermNumber;
	}
	
}
