package com.anpgames.beans.request;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;

@ManagedBean
@RequestScoped
public class ErrorMB {
	private Integer statusCode;
	private String message;
	private Class exceptionType;
	private Throwable exception;
	private String requestURI;
	private String servletName;
	
	@SuppressWarnings("rawtypes")
	@PostConstruct
	public void init() {
		FacesContext context = FacesContext.getCurrentInstance();
		Map<String, Object> reqMap = context.getExternalContext().getRequestMap();
		statusCode = (Integer) reqMap.get("javax.servlet.error.status_code");
		message = (String) reqMap.get("javax.servlet.error.message");
		exceptionType = (Class) reqMap.get("javax.servlet.error.exception_type");
		exception = (Throwable) reqMap.get("javax.servlet.error.exception");
		requestURI = (String) reqMap.get("javax.servlet.error.request_uri");
		servletName = (String) reqMap.get("javax.servlet.error.servlet_name");
	}
	
	public Integer getStatusCode() {
		return statusCode;
	}

	public String getMessage() {
		return message;
	}

	public Class getExceptionType() {
		return exceptionType;
	}
	
	public String getException() {
		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw);
		exception.printStackTrace(pw);
		return sw.toString();
	}

	public String getRequestURI() {
		return requestURI;
	}

	public String getServletName() {
		return servletName;
	}

}
