package com.anpgames.beans.session;

import java.io.Serializable;
import java.util.Locale;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

import com.anpgames.beans.application.MessagesSupportMB.Bundle;
import com.anpgames.beans.application.MessagesSupportMB;

@ManagedBean
@SessionScoped
public class LocaleMB implements Serializable {
	private static final long serialVersionUID = 2643870058288397121L;
	private String locale;
	private LocaleType actualLocaleType;
	
	public static enum LocaleType {
		PL,
		EN
	}
	
	@ManagedProperty(value="#{messagesSupportMB}")
	private MessagesSupportMB msgsSupport;
	
	@PostConstruct
	public void init() {
		this.locale = "pl";
		this.actualLocaleType = LocaleType.PL;
	}
	
	public void setMsgsSupport(MessagesSupportMB ms) {
		this.msgsSupport = ms;
	}
	
	public String getLocale() {
		return locale;
	}
	
	public String getLocalizedMessage(Bundle bundle, String key) {
		return msgsSupport.getMessage(actualLocaleType, bundle, key);
	}
	
	public void changeLocale(String locale) {
		this.locale = locale;
		if (locale.equals("pl"))
			actualLocaleType = LocaleType.PL;
		else if (locale.equals("en"))
			actualLocaleType = LocaleType.EN;
		FacesContext.getCurrentInstance().getViewRoot().setLocale(new Locale(locale));
	}
}
