package com.anpgames.modules.admin.beans.request;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;

import com.anpgames.beans.application.MessagesSupportMB.Bundle;
import com.anpgames.beans.application.MessagesSupportMB.MsgType;
import com.anpgames.beans.session.LocaleMB;
import com.anpgames.classes.MBSupportClass;
import com.anpgames.modules.admin.entities.Permission;
import com.anpgames.modules.admin.entities.Role;
import com.anpgames.modules.admin.slsbeans.basic.role.RoleBeanLocal;

@ManagedBean
@SessionScoped
public class RolesMB extends MBSupportClass implements Serializable {
	private static final long serialVersionUID = -2722449409935575431L;
	private Role role = new Role();
	private List<Role> roles;
	private List<Permission> permissions;
	
	@EJB RoleBeanLocal roleBean;
	@ManagedProperty(value="#{localeMB}")
	private LocaleMB localeMB;
	
	@PostConstruct
	public void init() {
		this.roles = roleBean.getRoles();
	}
	
	public void setLocaleMB(LocaleMB l) {
		this.localeMB = l;
	}

	public Role getRole() {
		return role;
	}
	public void setRole(Role role) {
		this.role = role;
	}
	
	public List<Role> getRoles() {
		return roles;
	}
	
	public List<Permission> getPermissions() {
		return permissions;
	}
	
	public String editRole(Role r) {
		role = r;
		permissions = roleBean.getMarkedPermissions(role.getRoleId());
		return "rolesEdit";
	}
	
	public String editRoleSave() {
		List<Permission> markedPermissions = new ArrayList<Permission>();
		for(Permission p : permissions) {
			if (p.getChecked())
				markedPermissions.add(p);
		}
		roleBean.updateRole(role, markedPermissions);
		setRespMsgCSSClass(MsgType.SUCCESS);
		setRespMsg(localeMB.getLocalizedMessage(Bundle.MSGS_ADMIN, "page.rolesList.msg.editSuccess"));
		return "rolesList";
	}
}