package com.anpgames.modules.admin.beans.request;

import java.io.Serializable;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;

import com.anpgames.beans.application.MessagesSupportMB.Bundle;
import com.anpgames.beans.application.MessagesSupportMB.MsgType;
import com.anpgames.beans.session.LocaleMB;
import com.anpgames.classes.MBSupportClass;
import com.anpgames.entities.User;
import com.anpgames.slsbeans.basic.user.UserBeanLocal;

@ManagedBean
@SessionScoped
public class UsersMB extends MBSupportClass implements Serializable {
	private static final long serialVersionUID = -3678651459359620759L;
	private List<User> users;
	
	private User user = new User();
	
	@EJB UserBeanLocal userBean;
	@ManagedProperty(value="#{localeMB}")
	private LocaleMB localeMB;
	
	@PostConstruct
	public void init() {
		this.users = userBean.getUsers();
	}
	
	public void setLocaleMB(LocaleMB l) {
		this.localeMB = l;
	}
	
	public User getUser() {
		return user;
	}
	public void setUser(User user) {
		this.user = user;
	}
	
	public List<User> getUsers() {
		return users;
	}
	
	public String editUser(User u) {
		user = u;
		return "usersEdit";
	}
	
	public String editUserSave() {
		userBean.updateUser(user);
		setRespMsgCSSClass(MsgType.SUCCESS);
		setRespMsg(localeMB.getLocalizedMessage(Bundle.MSGS_ADMIN, "page.usersList.msg.editSuccess"));
		return "usersList";
	}
	
}
