package com.anpgames.modules.admin.entities;

import java.io.Serializable;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.*;

import com.anpgames.entities.User;

/**
 * Entity implementation class for Entity: Group
 *
 */
@Entity
@Table(name="APP_GROUPS")
public class Group implements Serializable {
	private static final long serialVersionUID = 2883855663103900511L;
	
	@Id
	@GeneratedValue
	@Column(name="GROUP_ID")
	private int groupId;
	
	
	@Column(name="GROUP_NAME", length=50, nullable=false, unique=true)
	private String groupName;
	
	
	@Temporal(TemporalType.DATE)
	@Column(name="CREATION_DATE")
	private Date creationDate;
	
	@Temporal(TemporalType.DATE)
	@Column(name="LAST_UPDATE_DATE")
	private Date lastUpdateDate;
	
	@ManyToMany(mappedBy="groups",
			fetch=FetchType.LAZY)
	private Set<User> users = new HashSet<User>();
	
	@ManyToMany(fetch=FetchType.LAZY)
	@JoinTable(name="ACL_GROUPS_ROLES",
			joinColumns=@JoinColumn(name="GROUP_ID"),
			inverseJoinColumns=@JoinColumn(name="ROLE_ID"))
	private Set<Role> roles = new HashSet<Role>();
	
	
	public Group() {
		super();
	}

	
	public int getGroupId() {
		return groupId;
	}
	public void setGroupId(int groupId) {
		this.groupId = groupId;
	}

	
	public String getGroupName() {
		return groupName;
	}
	public void setGroupName(String groupName) {
		this.groupName = groupName;
	}
	
	
	public Date getCreationDate() {
		return creationDate;
	}
	public void setCreationDate(Date creationDate) {
		this.creationDate = creationDate;
	}
	
	
	public Date getLastUpdateDate() {
		return lastUpdateDate;
	}
	public void setLastUpdateDate(Date lastUpdateDate) {
		this.lastUpdateDate = lastUpdateDate;
	}

	
	public void setUsers(Set<User> users) {
		this.users = users;
	}
	public Set<User> getUsers() {
		return users;
	}


	public void setRoles(Set<Role> roles) {
		this.roles = roles;
	}
	public Set<Role> getRoles() {
		return roles;
	}
   
}
