package com.anpgames.modules.admin.entities;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.*;

import com.anpgames.entities.Context;

/**
 * Entity implementation class for Entity: Permission
 *
 */
@Entity
@Table(name="ACL_PERMISSIONS")
public class Permission implements Serializable {
	private static final long serialVersionUID = 4557886903589300123L;
	
	@Id
	@GeneratedValue
	@Column(name="PERMISSION_ID")
	private int permissionId;
	
	@Column(name="PERMISSION_NUMBER")
	private int permissionNumber;
	
	@Column(name="PERMISSION_NAME", length=200, nullable=false, unique=true)
	private String permissionName;
	
	@Temporal(TemporalType.DATE)
	@Column(name="CREATION_DATE")
	private Date creationDate;
	
	@Temporal(TemporalType.DATE)
	@Column(name="LAST_UPDATE_DATE")
	private Date lastUpdateDate;
	
	@ManyToOne
	@JoinColumn(name="CONTEXT_ID")
	private Context context;
	
	@Transient
	private Boolean checked;

	
	public Permission() {
		super();
	}

	
	public int getPermissionId() {
		return permissionId;
	}
	public void setPermissionId(int permissionId) {
		this.permissionId = permissionId;
	}

	
	public void setPermissionNumber(int permissionNumber) {
		this.permissionNumber = permissionNumber;
	}
	public int getPermissionNumber() {
		return permissionNumber;
	}


	public String getPermissionName() {
		return permissionName;
	}
	public void setPermissionName(String permissionName) {
		this.permissionName = permissionName;
	}


	public Date getCreationDate() {
		return creationDate;
	}
	public void setCreationDate(Date creationDate) {
		this.creationDate = creationDate;
	}

	
	public Date getLastUpdateDate() {
		return lastUpdateDate;
	}
	public void setLastUpdateDate(Date lastUpdateDate) {
		this.lastUpdateDate = lastUpdateDate;
	}


	public void setContext(Context context) {
		this.context = context;
	}
	public Context getContext() {
		return context;
	}


	public void setChecked(Boolean checked) {
		this.checked = checked;
	}
	public Boolean getChecked() {
		return checked;
	}
}
