package com.anpgames.modules.admin.slsbeans.basic.role;

import java.util.Date;
import java.util.List;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import com.anpgames.modules.admin.entities.Permission;
import com.anpgames.modules.admin.entities.Role;

/**
 * Session Bean implementation class RoleBean
 */
@Stateless
public class RoleBean implements RoleBeanLocal {
	@PersistenceContext(unitName="tsPU")
	private EntityManager manager;
	
	/**
	 * Default constructor. 
	 */
	public RoleBean() {
		// TODO Auto-generated constructor stub
	}
	
	@Override
	public void createRole(Role r) {
		manager.persist(r);
	}
	
	@Override
	public void updateRole(Role r, List<Permission> p) {
		Role role = manager.find(Role.class, r.getRoleId());
		role.setRoleName(r.getRoleName());
		role.getPermissions().clear();
		role.setPermissions(p);
		role.setLastUpdateDate(new Date());
		manager.flush();
	}
	
	@Override
	public Role findRole(int pKey) {
		return manager.find(Role.class, pKey);
	}
	
	@Override
	@SuppressWarnings("unchecked")
	public List<Role> getRoles() {
		List<Role> list = null;
		String q = "SELECT r FROM Role r";
		Query query = manager.createQuery(q);
		list = query.getResultList();
		
		return list;
	}
	
	@Override
	public List<Permission> getRolePermissions(int pKey) {
		Role r = manager.find(Role.class, pKey);
		List<Permission> list = r.getPermissions();
		list.size();
		return list;
	}
	
	@Override
	@SuppressWarnings("unchecked")
	public List<Permission> getMarkedPermissions(int pKey) {
		Role r = manager.find(Role.class, pKey);
		List<Permission> rolePermissions = r.getPermissions();
		rolePermissions.size();
		
		String q = "SELECT p FROM Permission p";
		Query query = manager.createQuery(q);
		List<Permission> allPermissions = query.getResultList();
		
		for (Permission p : rolePermissions) {
			Permission p2 = allPermissions.get(allPermissions.indexOf(p));
			p2.setChecked(true);
		}
		
		return allPermissions;
	}
}
